package	jp.co.sds_corp.fxutil;

import java.util.Date;
import java.util.List;
import java.util.Map;

import jp.co.sds_corp.fxutil.cache.CalendarCache;
import jp.co.sds_corp.fxutil.cache.CcyCache;
import jp.co.sds_corp.fxutil.cache.CcyPairCache;
import jp.co.sds_corp.fxutil.cache.TermCache;

/**
* 各マスタのキャッシュです。
*/
public class MasterCache
{
	static MasterCache master;
	CcyCache		ccy;
	CcyPairCache	ccypair;
	CalendarCache	cal;
	TermCache		term;

	protected MasterCache() {
	}

	public static MasterCache getInstance() {
		if ( master == null ) {
			master = new MasterCache();
			master.ccy = new CcyCache();
			master.ccypair = new CcyPairCache();
			master.cal = new CalendarCache();
			master.term = new TermCache();
		}
		return master;
	}

	public CcyCache getCcyCache() {
		return ccy;
	}
	public CcyPairCache getCcyPairCache() {
		return ccypair;
	}
	public CalendarCache getCalendarCache() {
		return cal;
	}
	public TermCache getTermCache() {
		return term;
	}

	public Map<String,Ccy> mapCcy() {
		return ccy.mapCcy();
	}
	public Ccy getCcy( String ccy_code ) {
		return ccy.getCcy( ccy_code );
	}

	public Map<String,CcyPair> mapCcyPair() {
		return ccypair.mapCcyPair();
	}
	public CcyPair getCcyPair( String ccy1, String ccy2 ) {
		return ccypair.getCcyPair( ccy1, ccy2 );
	}
	public CcyPair getCcyPair( Ccy ccy1, Ccy ccy2 ) {
		return ccypair.getCcyPair( ccy1, ccy2 );
	}

	public List<String> getDefaultTermList() {
		return term.getDefaultTermList();
	}

	public boolean isHoliday( Ccy ccy, Date date ) {
		return cal.isHoliday( ccy, date );
	}

}
